UNIT mTEllipse;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses ExtCtrls, Graphics, mTRundobjekt;

type
  TEllipse = class(TRundobjekt)

  private //Attribute
    Radiusx : integer;
    Radiusy : integer;

  public //Methoden
    constructor create (x: integer; y: integer; rx: integer; ry: integer; LF: TColor; FF: TColor); virtual;
    procedure SetzeRadiusx (pRadiusx: integer); virtual;
    procedure SetzeRadiusy (pRadiusy: integer); virtual;
    procedure Zeichnen (PB: TPaintbox); override;
    function GibRadiusx : integer; virtual;
    function GibRadiusy : integer; virtual;
    procedure Markiere(pb: TPaintbox); override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEllipse: Methodendefinition 
//+---------------------------------------------------------------------

//-------- create (public) ---------------------------------------------
constructor TEllipse.create (x: integer; y: integer; rx: integer; ry: integer; LF: TColor; FF: TColor);
begin
  inherited create(x,y,LF,FF);
  Radiusx:= rx;
  Radiusy:= ry;
end;

//-------- SetzeRadiusx (public) ---------------------------------------
procedure TEllipse.SetzeRadiusx (pRadiusx: integer);
begin
  Radiusx := pRadiusx
end;

//-------- SetzeRadiusy (public) ---------------------------------------
procedure TEllipse.SetzeRadiusy (pRadiusy: integer);
begin
  Radiusy := pRadiusy
end;

//-------- Zeichnen (public) -------------------------------------------
procedure TEllipse.Zeichnen (PB: TPaintbox);
begin
  inherited Zeichnen(PB);
  PB.Canvas.Ellipse(GibMittelpunkt.GibX-Radiusx,GibMittelpunkt.GibY-Radiusy,
                    GibMittelpunkt.GibX+Radiusx,GibMittelpunkt.GibY+Radiusy);
end;

//-------- GibRadiusx (public) -----------------------------------------
function TEllipse.GibRadiusx : integer;
begin
  result  := Radiusx
end;

//-------- GibRadiusy (public) -----------------------------------------
function TEllipse.GibRadiusy : integer;
begin
  result  := Radiusy
end;

//-------- Markiere (public) -----------------------------------------
procedure TEllipse.Markiere(pb: TPaintbox);
begin
  pb.canvas.Brush.style:= bsClear;
  pb.canvas.Pen.color:= clblack;
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-4,GibMittelpunkt.GibY-4,GibMittelpunkt.GibX+4,GibMittelpunkt.GibY+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-GibRadiusx-4,GibMittelpunkt.GibY-4,GibMittelpunkt.GibX-GibRadiusx+4,GibMittelpunkt.GibY+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX+GibRadiusx-4,GibMittelpunkt.GibY-4,GibMittelpunkt.GibX+GibRadiusx+4,GibMittelpunkt.GibY+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-4,GibMittelpunkt.GibY-GibRadiusy-4,GibMittelpunkt.GibX+4,GibMittelpunkt.GibY-GibRadiusy+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-4,GibMittelpunkt.GibY+GibRadiusy-4,GibMittelpunkt.GibX+4,GibMittelpunkt.GibY+GibRadiusy+4);
end;

end.
