UNIT mTLinie;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses ExtCtrls, Graphics, mTPunkt, mTLeerobjekt;

type
  TLinie = class(TLeerobjekt)

  private //Attribute
    Endpunkt : TPunkt;
    Startpunkt : TPunkt;

     //Objektbeziehungen:
        // hatTPunkt1, // hatTPunkt2 : TPunkt;

  public //Methoden
    constructor create (x1: integer; y1: integer; x2: integer; y2: integer; LF: TColor); virtual;
    procedure SetzeEndpunkt (pEndpunkt: TPunkt); virtual;
    procedure SetzeStartpunkt (pStartpunkt: TPunkt); virtual;
    procedure Zeichnen (PB: TPaintbox); override;
    function GibEndpunkt : TPunkt; virtual;
    function GibStartpunkt : TPunkt; virtual;
    destructor destroy; override;
    procedure Markiere(PB: TPaintbox); override;
   end;

implementation

//+---------------------------------------------------------------------
//|         TLinie: Methodendefinition 
//+---------------------------------------------------------------------

//-------- create (public) ---------------------------------------------
constructor TLinie.create (x1: integer; y1: integer; x2: integer; y2: integer; LF: TColor);
begin
  inherited create(LF);
  Startpunkt:= TPunkt.create(x1,y1,LF);
  Endpunkt:= TPunkt.create(x2,y2,LF);
end;

//-------- SetzeEndpunkt (public) --------------------------------------
procedure TLinie.SetzeEndpunkt (pEndpunkt: TPunkt);
begin
  Endpunkt := pEndpunkt
end;

//-------- SetzeStartpunkt (public) ------------------------------------
procedure TLinie.SetzeStartpunkt (pStartpunkt: TPunkt);
begin
  Startpunkt := pStartpunkt
end;

//-------- Zeichnen (public) -------------------------------------------
procedure TLinie.Zeichnen (PB: TPaintbox);
begin
  inherited Zeichnen(PB);
  PB.Canvas.MoveTo(Startpunkt.Gibx,Startpunkt.Giby);
  PB.Canvas.LineTo(Endpunkt.Gibx,Endpunkt.Giby);
end;

//-------- GibEndpunkt (public) ----------------------------------------
function TLinie.GibEndpunkt : TPunkt;
begin
  result  := Endpunkt
end;

//-------- GibStartpunkt (public) --------------------------------------
function TLinie.GibStartpunkt : TPunkt;
begin
  result  := Startpunkt
end;

//-------- destroy (public) --------------------------------------------
destructor TLinie.destroy;
begin
  Endpunkt.free;
  Startpunkt.free;
  inherited destroy;
end;

//-------- Markiere (public) -----------------------------------------
procedure TLinie.Markiere(pb: TPaintbox);
begin
  inherited Markiere(PB);
  pb.Canvas.Rectangle(GibStartpunkt.GibX-4,GibStartPunkt.GibY-4,GibStartpunkt.GibX+4,GibStartpunkt.GibY+4);
  pb.Canvas.Rectangle(GibEndpunkt.GibX-4,GibEndPunkt.GibY-4,GibEndpunkt.GibX+4,GibEndpunkt.GibY+4);
end;

end.
