UNIT mTkreis;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses ExtCtrls, Graphics, mTRundobjekt;

type
  Tkreis = class(TRundobjekt)

  private //Attribute
    Radius : integer;

  public //Methoden
    constructor create (x: integer; y: integer; r: integer; LF: TColor; FF: TColor); virtual;
    procedure SetzeRadius (pRadius: integer); virtual;
    procedure Zeichnen (PB: TPaintbox); override;
    function GibRadius : integer; virtual;
    procedure Markiere(PB: TPaintbox); override;
   end;

implementation

//+---------------------------------------------------------------------
//|         Tkreis: Methodendefinition
//+---------------------------------------------------------------------

//-------- create (public) ---------------------------------------------
constructor Tkreis.create (x: integer; y: integer; r: integer; LF: TColor; FF: TColor);
begin
  inherited create(x,y,LF,FF);
  Radius:= r;
end;

//-------- SetzeRadius (public) ----------------------------------------
procedure Tkreis.SetzeRadius (pRadius: integer);
begin
  Radius := pRadius
end;

//-------- Zeichnen (public) -------------------------------------------
procedure Tkreis.Zeichnen (PB: TPaintbox);
begin
  inherited Zeichnen(PB);
  PB.Canvas.Ellipse(GibMittelpunkt.GibX-Radius,GibMittelpunkt.GibY-Radius,
                    GibMittelpunkt.GibX+Radius,GibMittelpunkt.GibY+Radius);
end;

//-------- GibRadius (public) ------------------------------------------
function Tkreis.GibRadius : integer;
begin
  result  := Radius
end;

//-------- Markiere (public) -----------------------------------------
procedure TKreis.Markiere(pb: TPaintbox);
begin
  inherited Markiere(PB);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-4,GibMittelpunkt.GibY-4,GibMittelpunkt.GibX+4,GibMittelpunkt.GibY+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-GibRadius-4,GibMittelpunkt.GibY-4,GibMittelpunkt.GibX-GibRadius+4,GibMittelpunkt.GibY+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX+GibRadius-4,GibMittelpunkt.GibY-4,GibMittelpunkt.GibX+GibRadius+4,GibMittelpunkt.GibY+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-4,GibMittelpunkt.GibY-GibRadius-4,GibMittelpunkt.GibX+4,GibMittelpunkt.GibY-GibRadius+4);
  pb.Canvas.Rectangle(GibMittelpunkt.GibX-4,GibMittelpunkt.GibY+GibRadius-4,GibMittelpunkt.GibX+4,GibMittelpunkt.GibY+GibRadius+4);
end;

end.
