unit mtGrafikliste;

interface

uses U_List, mtZeichenobjekt, ExtCtrls;

type TGrafikliste = class
     private
       pObjekte: TLinList;
       pPaintbox: TPaintbox;
     public
       constructor create(PB: TPaintbox);
       procedure previous;
       procedure next;
       procedure toFirst;
       procedure toLast;
       procedure insert(o: TZeichenobjekt);
       procedure delete;
       procedure refresh;
       destructor destroy;
       procedure sendToBack;
       procedure sendToFront;
     end;

implementation

constructor TGrafikliste.create(PB: TPaintbox);
begin
 pPaintbox:= PB;
 pObjekte:= TLinList.create;
end;

procedure TGrafikliste.previous;
begin
  pObjekte.previous;
  if pObjekte.isBefore then pObjekte.next;
  refresh;
end;

procedure TGrafikliste.next;
begin
  pObjekte.next;
  if pObjekte.isBehind then pObjekte.previous;
  refresh;
end;

procedure TGrafikliste.toFirst;
begin
  pObjekte.toFirst;
  refresh;
end;

procedure TGrafikliste.toLast;
begin
  pObjekte.toLast;
  refresh;
end;

procedure TGrafikliste.insert(o: TZeichenobjekt);
begin
  pObjekte.toLast;
  pObjekte.insertBehind(o);
  pObjekte.next;
  refresh;
end;

procedure TGrafikliste.refresh;
var o: TZeichenobjekt;
begin
  o:= TZeichenobjekt(pObjekte.getItem);
  pPaintbox.Refresh;
  pObjekte.toFirst;
  while not pObjekte.isBehind
  do begin
       TZeichenobjekt(pObjekte.getItem).Zeichnen(pPaintbox);
       pObjekte.next;
     end;
  if o<> nil
  then begin
          pObjekte.toFirst;
          while (not pObjekte.isBehind) and (pObjekte.getItem<>o)
          do pObjekte.next;
          o.Markiere(pPaintbox);
       end;
end;

procedure TGrafikliste.delete;
begin
  if pObjekte.getItem<>nil
  then begin
         pObjekte.getItem.Free;
         pObjekte.delete;
         if pObjekte.isBehind then pObjekte.previous;
         refresh;
       end;

end;

destructor TGrafikliste.destroy;
begin
  pObjekte.Free;
  inherited destroy;
end;

procedure TGrafikliste.sendToBack;
var o1, o2: TZeichenobjekt;
begin
  o1:= TZeichenobjekt(pObjekte.getItem);
  pObjekte.next;
  if pObjekte.isBehind
  then pObjekte.previous
  else begin
         o2:= TZeichenobjekt(pObjekte.getItem);
         pObjekte.update(o1);
         pObjekte.previous;
         pObjekte.update(o2);
         pObjekte.next;
       end;
  refresh;
end;

procedure TGrafikliste.sendToFront;
var o1, o2: TZeichenobjekt;
begin
  o1:= TZeichenobjekt(pObjekte.getItem);
  pObjekte.previous;
  if pObjekte.isBefore
  then pObjekte.next
  else begin
         o2:= TZeichenobjekt(pObjekte.getItem);
         pObjekte.update(o1);
         pObjekte.next;
         pObjekte.update(o2);
         pObjekte.previous;
       end;
  refresh;
end;

end.
